1
1
Atdalīts 0
Nevar pievienot vairāk kā 25 tēmas Tēmai ir jāsākas ar burtu vai ciparu, tā var saturēt domu zīmes ('-') un var būt līdz 35 simboliem gara.

73 rindas
1.2 KiB

pirms 6 gadiem
#!/usr/bin/env bash
pirms 6 gadiem
declare -r esc=$'\033'
declare -r c_reset="${esc}[0m"
declare -r c_red="${esc}[31m"
pirms 6 gadiem
declare -r fifo='/tmp/sshget.fifo'
declare -A domains=()
declare -A paths=()
declare -a files=()
err() {
printf "${c_red}%s${c_reset}\n" "$*" >&2
}
die() {
exit 1
}
pirms 6 gadiem
usage() {
LESS=-FEXR less <<'HELP'
sshget <user@host1:/path/to/search ...>
HELP
}
has() {
pirms 6 gadiem
local verbose=0
if [[ $1 = '-v' ]]; then
pirms 6 gadiem
verbose=1
shift
fi
pirms 6 gadiem
for c; do c="${c%% *}"
if ! command -v "$c" &> /dev/null; then
pirms 6 gadiem
(( verbose > 0 )) && err "$c not found"
return 1
fi
done
}
has -v fzf rsync || die
pirms 6 gadiem
cleanup() {
[[ -e "$fifo" ]] && rm "$fifo"
}
trap cleanup SIGHUP SIGINT SIGTERM
mkfifo "$fifo"
pirms 6 gadiem
if (( $# < 1 )); then
usage
die
fi
pirms 6 gadiem
for a; do
pirms 6 gadiem
host="${a%:*}"
pirms 6 gadiem
path="${a##*:}"
domains+=( ["$a"]="$host" )
paths+=( ["$a"]="$path" )
shift
done
for s in "${!domains[@]}"; do
pirms 6 gadiem
ssh "${domains[$s]}" "find ${paths[$s]}" | sed -r "s|^|${domains[$s]}:|" >> "$fifo" &
pirms 6 gadiem
done
pirms 4 gadiem
mapfile -t files < <(fzf -e --inline-info +s --multi --cycle --bind='Ctrl-A:toggle-all,`:jump' < "$fifo")
pirms 6 gadiem
if (( ${#files[@]} )); then
rsync --protect-args -auvzP -e ssh "${files[@]}" .
pirms 6 gadiem
fi
cleanup